/*******************************************************************************
 * Copyright(c) 2022 dongke All rights reserved. / Confidential
 * 
 * 类的信息：
 *		1.程序名称：收发存汇总-明细
 * 编辑履历：
 *		作者				日期					版本				修改内容
 *		姜永辉		 2024-1-23			1.00		    选品
 *******************************************************************************/
const mixins = require('@/mixins/index.js')
const Constants = require('@/utils/Constants.js');
const app = getApp()
Page({
  mixins: [mixins],
  /**
   * 页面的初始数据
   */
  data: {
    // 路由
    routeObjName: 'report',
    // 待入库 已入库的taglist
    tagList: [
      { title: mixins.$t('inBoundOrder') ,code:'inBound'},
      { title: mixins.$t('outBoundOrder') ,code:'outBound'}],
    active: 0,
  },

  /**
  * @desc : 切换 待入库 已出库
  * @date : 2024年3月8日
  * @author : 姜永辉
  */
  onChangeTabs(e) {
    let index = e.detail.detail.index
    this.setData({
      active: index,
    })

    this.searchData()
  },

  /**
  * @desc : 设置查询参数
  * @date : 2024年3月8日
  * @author : 姜永辉
  */
  setSearchParams(params) {
    //收付款类型-收款的查询参数 
    params.invId = this.data.item.invId
    params.accDateStart = this.data.item.accDateStart
    params.accDateEnd = this.data.item.accDateEnd
    params.invType = this.data.active + 1
    return params;
  },

  /**
   * @desc : 查询
   * @date : 2024/2/1 15:49
   * @author : 姜永辉
   */
  getData(params) {
    return this.excute(this.data.service, this.data.service.getIvtItemReport, params);
  },
  /**
 * @desc : 处理接口返回数据
 * @date : 2024/2/1 15:49
 * @author : 姜永辉
 */
  handleSearchData(tableData) {
    console.log('tableData',tableData);
    //处理图片
    if (tableData && tableData.length > 0) {
      tableData.forEach(element => {
        element.imagesUrl = this.data.item.imagesUrl
      })
      this.setData({
        tableData: tableData,
      })
    }
  },

  /**
   * @desc : 包装数据计算
   * @date : 2024/6/5 09:03
   * @author : 刘尧
   */
  computeBoxNumber(item){
    console.log(item);
    // 期初
    item['openingBox'] = parseInt(item.openingIvtQty / item.packBox)
    item['openingPiece'] = parseFloat(Number(item.openingIvtQty % item.packBox)).toFixed(item.decimalPlaces)
    item.packageBoxOpening = item['openingBox'] + item.subUnitName + item['openingPiece'] + item.unitName
    // 入库
    item['currentBox'] = parseInt(item.currentIntoQty / item.packBox)
    item['currentPiece'] = parseFloat(Number(item.currentIntoQty % item.packBox)).toFixed(item.decimalPlaces) 
    item.packageBoxCurrent = item['currentBox'] + item.subUnitName + item['currentPiece'] + item.unitName
    // 出库
    item['currentOutBox'] = parseInt(item.currentOutQty / item.packBox)
    item['currentOutPiece'] = parseFloat(Number(item.currentOutQty % item.packBox)).toFixed(item.decimalPlaces) 
    item.packageBoxCurrentOut = item['currentOutBox'] + item.subUnitName + item['currentOutPiece'] + item.unitName
    // 期末
    item['endingIvtBox'] = parseInt(item.endingIvtQty / item.packBox)
    item['endingIvtPiece'] = parseFloat(Number(item.endingIvtQty % item.packBox)).toFixed(item.decimalPlaces) 
    item.packageBoxEndingIvt = item['endingIvtBox'] + item.subUnitName + item['endingIvtPiece'] + item.unitName
    this.setData({
      item: item
    })
  },
  /**
   * 跳转对应单据
   */
  toItem(param){
    const code = this.data.tagList[this.data.active].code;
    const data = param.currentTarget.dataset.value
    const e = {
      detail:{
        name: code,
        item: data
      }
    }
    // 跳转问题待解决
    this.open(e)
  },
  /**
   * 生命周期函数--监听页面加载
   */
  loadInit() {
    console.log(this.data.item, "loadInit");
    this.computeBoxNumber(this.data.item)
  },

})